package ch.std.jumpstartsecured;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.skyscreamer.jsonassert.JSONAssert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.http.MediaType;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;

import ch.std.jumpstartsecured.repository.UserRepository;
import ch.std.jumpstartsecured.rest.CityAutoCompleteController;

@RunWith(SpringRunner.class)
@WebMvcTest(CityAutoCompleteController.class)
@ActiveProfiles("test")
public class JumpstartApplicationTests {
	@Autowired
	private MockMvc mvc;
	
	@MockBean
	private UserRepository userRepository;

	@Test
	public void contextLoads() {
	}

	@Test
	@WithMockUser(username = "user", password="password", roles = { "USER" })
	public void testCityAutoCompleteController() throws Exception {
		MvcResult mvcResult = mvc.perform(get("/rest/auto/cities?value=Bern").contentType(MediaType.APPLICATION_JSON))
				.andExpect(status().isOk()).andReturn();
		String expected = "[Bern]";
		String actual = mvcResult.getResponse().getContentAsString();
		JSONAssert.assertEquals(expected, actual, false);
	}
}
